import { CosmWasmClient } from "@cosmjs/cosmwasm-stargate";
import { Chain, ChainAddress, ChainsConfig, Contracts, NativeAddress, Network, TokenBridge, TokenId, TokenTransferTransaction, TxHash } from "@wormhole-foundation/connect-sdk";
import { AnyCosmwasmAddress, CosmwasmChains, CosmwasmPlatformType, CosmwasmUnsignedTransaction } from "@wormhole-foundation/connect-sdk-cosmwasm";
export declare class CosmwasmTokenBridge<N extends Network, C extends CosmwasmChains> implements TokenBridge<N, CosmwasmPlatformType, C> {
    readonly network: N;
    readonly chain: C;
    readonly rpc: CosmWasmClient;
    readonly contracts: Contracts;
    private tokenBridge;
    private translator?;
    private constructor();
    static fromRpc<N extends Network>(rpc: CosmWasmClient, config: ChainsConfig<N, CosmwasmPlatformType>): Promise<CosmwasmTokenBridge<N, CosmwasmChains>>;
    isWrappedAsset(token: AnyCosmwasmAddress): Promise<boolean>;
    hasWrappedAsset(token: TokenId): Promise<boolean>;
    getWrappedAsset(token: TokenId<Chain>): Promise<NativeAddress<C>>;
    getOriginalAsset(token: AnyCosmwasmAddress): Promise<TokenId>;
    isTransferCompleted(vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">): Promise<boolean>;
    createAttestation(token: AnyCosmwasmAddress | "native", payer?: AnyCosmwasmAddress): AsyncGenerator<CosmwasmUnsignedTransaction<N, C>>;
    submitAttestation(vaa: TokenBridge.VAA<"AttestMeta">, payer?: AnyCosmwasmAddress): AsyncGenerator<CosmwasmUnsignedTransaction<N, C>>;
    transfer(sender: AnyCosmwasmAddress, recipient: ChainAddress, token: AnyCosmwasmAddress | "native", amount: bigint, payload?: Uint8Array): AsyncGenerator<CosmwasmUnsignedTransaction<N, C>>;
    redeem(sender: AnyCosmwasmAddress, vaa: TokenBridge.VAA<"Transfer" | "TransferWithPayload">, unwrapNative?: boolean): AsyncGenerator<CosmwasmUnsignedTransaction<N, C>>;
    parseTransactionDetails(txid: TxHash): Promise<TokenTransferTransaction[]>;
    getWrappedNative(): Promise<NativeAddress<C>>;
    private createUnsignedTx;
}
//# sourceMappingURL=tokenBridge.d.ts.map